% ֵ PSNRPeak Signal-to-Noise Ratio
function [PSNR,mse]=psnr(X,Y)
% function [PSNR,mse]=psnr(X,Y)
% Peak signal to noise ratio of the difference between images and the 
% mean square error
%    If the second input Y is missing then the PSNR and MSE of X itself 
% becomes the output (as if Y=0).
X=double(X);
Y=double(Y);
if nargin<2, D=X;
else
   if any(size(X)~=size(Y))
       error('The input size is not equal to each other!'); 
   end
   D=X-Y;
end

mse=sum(D(:).*D(:))/numel(X);
PSNR=10*log10(255^2/mse);
disp(sprintf('PSNR = +%5.4f dB',PSNR));
% disp(sprintf('MSE = +%5.4f dB',mse));